// Dinamic - nr de subs cresc de lungime maxima
#include <fstream>
#include <iomanip>
using namespace std;


int a[100];
int n;
int b[100][100];    // b[i][k] - nr de subsiruri crescatoare de lungime k, care se termina cu a[i] 

int Lmax;
void Read();
void Write();
void Dinamic();

int main()
{
	Read();
	Dinamic();
	Write();
	
	return 0;
}

void Dinamic()
{
	for ( int i = 0; i < n; ++i )
		b[i][1] = 1;	

	for ( int i = 0; i < n; ++i )
		for (int k = 1; k <= i; ++k )
			for ( int j = 0; j < i; ++j)
				if ( a[i] > a[j] )
					b[i][k] += b[j][k-1];
}


void Write()
{
	ofstream fout("1.out");
	
	for ( int i = 0; i < n; ++i )
	{
		for ( int j = 1; j < n; ++j )
			fout << setw(3) << b[i][j];
		fout << '\n';
	}
	
	// Lmax e lungimea celui mai lung subsir crescator
	bool gasit = false;
	for ( int j = n - 1; j >= 0 && !gasit; --j )
	{
		for ( int i = 0; i < n && !gasit; ++i )
			if ( b[i][j] )
			{
				gasit = true;
				Lmax = j;
			}
	}
	
	// Adun 
	int sum = 0;
	for ( int i = 0; i < n; ++i )
		sum += b[i][Lmax];
	fout << sum << " siruri de lungime " << Lmax;
	fout.close();
}

void Read()
{
	ifstream fin("1.in");
	fin >> n;
	for( int i =0; i < n; ++i )
		fin >> a[i];
	fin.close();
}
